#include <bits/stdc++.h>

using namespace std;

extern int guess_palindromicity(int);
int count_pair(int, int, int);
int find_character(int, std::vector<int>);
std::vector<std::vector<int>> shuffle(std::vector<std::vector<int>>);

static const std::string input_secret = "wHBDO4-INPUT-K2FZ4z";
static const std::string output_secret = "ppme3h-OUTPUT-dzfJFL";
static const std::string error_secret = "LmSUfv-Error-i8vxSx";


static int N, cnt1, cnt2, cnt3, sc;
static int S[5002];

void assertion(bool x, std::string msg) {
    if (x) return;
    cout << error_secret << "\n";
    cout << msg << endl;
    exit(0);
}

int count_pair(int x, int y, int z) {
    ++cnt1;
    assertion(cnt1 <= 2 * N, "Wrong Answer [3]");
    assertion(x != y && y != z && x != z, "Wrong Answer [1]");
    assertion(0 <= x && 0 <= y && 0 <= z &&
            x < N && y < N && z < N, "Wrong Answer [1]");
            
    int ret = 0;
    if(S[x] == S[y]) ++ret;
    if(S[y] == S[z]) ++ret;
    if(S[z] == S[x]) ++ret;
    
    return ret;
}

int find_character(int x, std::vector<int> Y) {
    ++cnt2;
    assertion(cnt2 <= N, "Wrong Answer [4]");
    assertion(0 <= x && x < N, "Wrong Answer [2]");
    cnt3 += (int)Y.size();
    assertion(cnt3 <= N, "Wrong Answer [5]");
    for(int y : Y) {
        assertion(0 <= y && y < N, "Wrong Answer [2]");
    }
    for(int y : Y) {
        if(S[x] == S[y]) return 1;
    }
    return 0;
}

void ask() {
    cin >> N;
    for(int i=0;i<N;i++) cin >> S[i];
    
    cnt1 = 0; cnt2 = 0; cnt3 = 0;
    int res = guess_palindromicity(N);
    
    int ans = 1;
    for(int i=0;i<N/2;i++) if(S[i] != S[N-1-i]) ans = 0;
    assertion(res == ans, "Wrong Answer [6]");
    
    if(cnt2 >= 2) sc = min(sc, 15);
    else if(cnt1 > N) sc = min(sc, 50);
    else if(cnt1 > N/2 + 2) sc = min(sc, 70);
    else if(cnt1 == N/2 + 2) sc = min(sc, 90);
    else sc = min(sc, 100);
}

int main() {
    ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
    string zzz; cin >> zzz;
	assertion(zzz == input_secret, "input secret is wrong?");
	
	sc = 100;

	int T; cin >> T;
    while(T--) {
        ask();
    }
    
    cout << output_secret << "\n";
    cout << sc << endl;
}
